Enable OpenDaylight clustering mode for FDIO scenarios
[apex.git] / lib / overcloud-deploy-functions.sh
1 #!/usr/bin/env bash
2 ##############################################################################
3 # Copyright (c) 2015 Tim Rozet (Red Hat), Dan Radez (Red Hat) and others.
4 #
5 # All rights reserved. This program and the accompanying materials
6 # are made available under the terms of the Apache License, Version 2.0
7 # which accompanies this distribution, and is available at
8 # http://www.apache.org/licenses/LICENSE-2.0
9 ##############################################################################
10
11 ##preping it for deployment and launch the deploy
12 ##params: none
13 function overcloud_deploy {
14   local num_compute_nodes
15   local num_control_nodes
16   local dpdk_cores pmd_cores socket_mem ovs_dpdk_perf_flag ovs_option_heat_arr
17   declare -A ovs_option_heat_arr
18
19   ovs_option_heat_arr['dpdk_cores']=OvsDpdkCoreList
20   ovs_option_heat_arr['pmd_cores']=PmdCoreList
21   ovs_option_heat_arr['socket_memory']=OvsDpdkSocketMemory
22
23   # OPNFV Default Environment and Network settings
24   DEPLOY_OPTIONS+=" -e ${ENV_FILE}"
25   DEPLOY_OPTIONS+=" -e network-environment.yaml"
26
27   # Custom Deploy Environment Templates
28   if [[ "${#deploy_options_array[@]}" -eq 0 || "${deploy_options_array['sdn_controller']}" == 'opendaylight' ]]; then
29     if [ "${deploy_options_array['sfc']}" == 'True' ]; then
30       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight_sfc.yaml"
31     elif [ "${deploy_options_array['vpn']}" == 'True' ]; then
32       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-bgpvpn.yaml"
33       if [ "${deploy_options_array['gluon']}" == 'True' ]; then
34         DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/services/gluon.yaml"
35       fi
36     elif [ "${deploy_options_array['vpp']}" == 'True' ]; then
37       if [ "${deploy_options_array['odl_vpp_netvirt']}" == "True" ]; then
38         DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-netvirt-vpp.yaml"
39       elif [ "${deploy_options_array['sdn_l3']}" == "True" ]; then
40         DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-honeycomb.yaml"
41       else
42         DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-honeycomb-l2.yaml"
43       fi
44     else
45       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-l3.yaml"
46     fi
47     SDN_IMAGE=opendaylight
48   elif [ "${deploy_options_array['sdn_controller']}" == 'opendaylight-external' ]; then
49     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight-external.yaml"
50     SDN_IMAGE=opendaylight
51   elif [ "${deploy_options_array['sdn_controller']}" == 'onos' ]; then
52     echo -e "${red}ERROR: ONOS is unsupported in Danube...exiting${reset}"
53     exit 1
54     #if [ "${deploy_options_array['sfc']}" == 'True' ]; then
55     #  DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/onos_sfc.yaml"
56     #else
57     #  DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/onos.yaml"
58     #fi
59     #SDN_IMAGE=onos
60   elif [ "${deploy_options_array['sdn_controller']}" == 'ovn' ]; then
61     if [[ "$ha_enabled" == "True" ]]; then
62       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-ml2-ovn-ha.yaml"
63       echo "${red}OVN HA support is not not supported... exiting.${reset}"
64       exit 1
65     else
66       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-ml2-ovn.yaml"
67     fi
68     SDN_IMAGE=opendaylight
69   elif [ "${deploy_options_array['sdn_controller']}" == 'opencontrail' ]; then
70     echo -e "${red}ERROR: OpenContrail is currently unsupported...exiting${reset}"
71     exit 1
72   elif [[ -z "${deploy_options_array['sdn_controller']}" || "${deploy_options_array['sdn_controller']}" == 'False' ]]; then
73     echo -e "${blue}INFO: SDN Controller disabled...will deploy nosdn scenario${reset}"
74     if [ "${deploy_options_array['vpp']}" == 'True' ]; then
75       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-ml2-vpp.yaml"
76     elif [ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' ]; then
77       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-ovs-dpdk.yaml"
78     fi
79     SDN_IMAGE=opendaylight
80   else
81     echo "${red}Invalid sdn_controller: ${deploy_options_array['sdn_controller']}${reset}"
82     echo "${red}Valid choices are opendaylight, opendaylight-external, onos, opencontrail, False, or null${reset}"
83     exit 1
84   fi
85
86   # Enable Tacker
87   if [ "${deploy_options_array['tacker']}" == 'True' ]; then
88     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/enable_tacker.yaml"
89   fi
90
91   # Enable Congress
92   if [ "${deploy_options_array['congress']}" == 'True' ]; then
93     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/enable_congress.yaml"
94   fi
95
96   # Enable Real Time Kernel (kvm4nfv)
97   if [ "${deploy_options_array['rt_kvm']}" == 'True' ]; then
98     DEPLOY_OPTIONS+=" -e /home/stack/enable_rt_kvm.yaml"
99   fi
100
101   # Make sure the correct overcloud image is available
102   if [ ! -f $IMAGES/overcloud-full-${SDN_IMAGE}.qcow2 ]; then
103       echo "${red} $IMAGES/overcloud-full-${SDN_IMAGE}.qcow2 is required to execute your deployment."
104       echo "Please install the opnfv-apex package to provide this overcloud image for deployment.${reset}"
105       exit 1
106   fi
107
108   echo "Copying overcloud image to Undercloud"
109   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "rm -f overcloud-full.qcow2"
110   scp ${SSH_OPTIONS[@]} $IMAGES/overcloud-full-${SDN_IMAGE}.qcow2 "stack@$UNDERCLOUD":overcloud-full.qcow2
111
112   # disable neutron openvswitch agent from starting
113   if [[ -n "${deploy_options_array['sdn_controller']}" && "${deploy_options_array['sdn_controller']}" != 'False' ]]; then
114       echo -e "${blue}INFO: Disabling neutron-openvswitch-agent from systemd${reset}"
115       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
116       LIBGUESTFS_BACKEND=direct virt-customize --run-command "rm -f /etc/systemd/system/multi-user.target.wants/neutron-openvswitch-agent.service" \
117                                                --run-command "rm -f /usr/lib/systemd/system/neutron-openvswitch-agent.service" \
118                                                -a overcloud-full.qcow2
119 EOI
120   fi
121
122   if [ "${deploy_options_array['vpn']}" == 'True' ]; then
123       echo -e "${blue}INFO: Enabling ZRPC and Quagga${reset}"
124       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
125       LIBGUESTFS_BACKEND=direct virt-customize \
126          --run-command "cd /root/quagga; packages=\\\$(ls |grep -vE 'debuginfo|devel|contrib'); yum -y install \\\$packages" \
127          --run-command "sudo usermod -a -G quaggavt quagga" \
128          --run-command "systemctl enable zrpcd" \
129          -a overcloud-full.qcow2
130 EOI
131   fi
132
133   # Install ovs-dpdk inside the overcloud image if it is enabled.
134   if [[ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' || "${deploy_options_array['dataplane']}" == 'fdio' ]]; then
135     # install dpdk packages before ovs
136     echo -e "${blue}INFO: Enabling kernel modules for dpdk inside overcloud image${reset}"
137
138     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
139       cat << EOF > vfio_pci.modules
140 #!/bin/bash
141 exec /sbin/modprobe vfio_pci >/dev/null 2>&1
142 EOF
143
144       cat << EOF > uio_pci_generic.modules
145 #!/bin/bash
146 exec /sbin/modprobe uio_pci_generic >/dev/null 2>&1
147 EOF
148
149       LIBGUESTFS_BACKEND=direct virt-customize --upload vfio_pci.modules:/etc/sysconfig/modules/ \
150                                                --upload uio_pci_generic.modules:/etc/sysconfig/modules/ \
151                                                --run-command "chmod 0755 /etc/sysconfig/modules/vfio_pci.modules" \
152                                                --run-command "chmod 0755 /etc/sysconfig/modules/uio_pci_generic.modules" \
153                                                -a overcloud-full.qcow2
154
155       if [ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' ]; then
156         sed -i "/OS::TripleO::ComputeExtraConfigPre:/c\  OS::TripleO::ComputeExtraConfigPre: ./ovs-dpdk-preconfig.yaml" network-environment.yaml
157       fi
158
159 EOI
160
161   elif [ "${deploy_options_array['dataplane']}" != 'ovs' ]; then
162     echo "${red}${deploy_options_array['dataplane']} not supported${reset}"
163     exit 1
164   fi
165
166   if [ "$debug" == 'TRUE' ]; then
167     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "LIBGUESTFS_BACKEND=direct virt-customize -a overcloud-full.qcow2 --root-password password:opnfvapex"
168   fi
169
170   # upgrade ovs into ovs 2.5.90 with NSH function if SFC is enabled
171   if [[ "${deploy_options_array['sfc']}" == 'True' && "${deploy_options_array['dataplane']}" == 'ovs' ]]; then
172     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
173          LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum install -y /root/ovs/rpm/rpmbuild/RPMS/x86_64/${ovs_kmod_rpm_name}" \
174                                                   --run-command "yum upgrade -y /root/ovs/rpm/rpmbuild/RPMS/x86_64/${ovs_rpm_name}" \
175                                                   -a overcloud-full.qcow2
176 EOI
177   fi
178
179   # Patch neutron with using OVS external interface for router and add generic linux NS interface driver
180   if [[ "${deploy_options_array['dataplane']}" == 'fdio' ]]; then
181     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
182       LIBGUESTFS_BACKEND=direct virt-customize --run-command "cd /usr/lib/python2.7/site-packages/ && patch -p1 < neutron-patch-NSDriver.patch" \
183                                                -a overcloud-full.qcow2
184 EOI
185
186     # Configure routing node for odl-fdio
187     if [[ "${deploy_options_array['sdn_l3']}" == 'True' ]]; then
188       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
189         sed -i "/opendaylight::vpp_routing_node:/c\    opendaylight::vpp_routing_node: ${deploy_options_array['odl_vpp_routing_node']}.${domain_name}" ${ENV_FILE}
190 EOI
191     fi
192   fi
193
194   if [ -n "${deploy_options_array['performance']}" ]; then
195     ovs_dpdk_perf_flag="False"
196     for option in "${performance_options[@]}" ; do
197       if [ "${arr[1]}" == "vpp" ]; then
198         if [ "${arr[0]}" == "Compute" ]; then
199           role='NovaCompute'
200         else
201           role=${arr[0]}
202         fi
203         if [ "${arr[2]}" == "main-core" ]; then
204           ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
205             sed -i "/${role}ExtraConfig:/ c\  ${role}ExtraConfig:\n    fdio::vpp_cpu_main_core: \"'${arr[3]}'\"" ${ENV_FILE}
206 EOI
207         elif [ "${arr[2]}" == "corelist-workers" ]; then
208           ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
209             sed -i "/${role}ExtraConfig:/ c\  ${role}ExtraConfig:\n    fdio::vpp_cpu_corelist_workers: \"'${arr[3]}'\"" ${ENV_FILE}
210 EOI
211         fi
212       fi
213       arr=($option)
214       # use compute's kernel settings for all nodes for now.
215       if [ "${arr[0]}" == "Compute" ] && [ "${arr[1]}" == "kernel" ]; then
216         kernel_args+=" ${arr[2]}=${arr[3]}"
217       fi
218       if [ "${arr[0]}" == "Compute" ] && [ "${arr[1]}" == "ovs" ]; then
219          eval "${arr[2]}=${arr[3]}"
220          ovs_dpdk_perf_flag="True"
221       fi
222     done
223
224     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
225       sed -i "/ComputeKernelArgs:/c\  ComputeKernelArgs: '$kernel_args'" ${ENV_FILE}
226       sed -i "$ a\resource_registry:\n  OS::TripleO::NodeUserData: first-boot.yaml" ${ENV_FILE}
227       sed -i "/NovaSchedulerDefaultFilters:/c\  NovaSchedulerDefaultFilters: 'RamFilter,ComputeFilter,AvailabilityZoneFilter,ComputeCapabilitiesFilter,ImagePropertiesFilter,NUMATopologyFilter'" ${ENV_FILE}
228 EOI
229
230     if [[ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' && "$ovs_dpdk_perf_flag" == "True" ]]; then
231       for ovs_option in ${!ovs_option_heat_arr[@]}; do
232         if [ -n "${!ovs_option}" ]; then
233           ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
234             sed -i "/${ovs_option_heat_arr[$ovs_option]}:/c\  ${ovs_option_heat_arr[$ovs_option]}: ${!ovs_option}" ${ENV_FILE}
235 EOI
236         fi
237       done
238     fi
239   fi
240
241   if [[ -z "${deploy_options_array['sdn_controller']}" || "${deploy_options_array['sdn_controller']}" == 'False' ]]; then
242     if [ "${deploy_options_array['dataplane']}" == "fdio" ]; then
243       if [ "$tenant_nic_mapping_controller_members" == "$tenant_nic_mapping_compute_members" ]; then
244         echo -e "${blue}INFO: nosdn fdio deployment...installing correct vpp packages...${reset}"
245         ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
246           sed -i "/NeutronVPPAgentPhysnets:/c\  NeutronVPPAgentPhysnets: 'datacentre:${tenant_nic_mapping_controller_members}'" ${ENV_FILE}
247 EOI
248       else
249         echo -e "${red}Compute and Controller must use the same tenant nic name, please modify network setting file.${reset}"
250         exit 1
251       fi
252     fi
253   fi
254
255   # Set ODL version accordingly
256   if [[ "${deploy_options_array['sdn_controller']}" == 'opendaylight' && -n "${deploy_options_array['odl_version']}" ]]; then
257     case "${deploy_options_array['odl_version']}" in
258       beryllium) odl_version=''
259               ;;
260       boron)  odl_version='boron'
261               ;;
262       carbon) odl_version='master'
263               ;;
264       *) echo -e "${red}Invalid ODL version ${deploy_options_array['odl_version']}.  Please use 'carbon' or 'boron' values.${reset}"
265          exit 1
266          ;;
267     esac
268
269     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
270       LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum -y remove opendaylight" \
271                                                --run-command "yum -y install /root/${odl_version}/*" \
272                                                -a overcloud-full.qcow2
273 EOI
274   fi
275
276   # Override ODL if we enable netvirt for fdio
277   if [[ "${deploy_options_array['odl_vpp_netvirt']}" == 'True' && "${deploy_options_array['sdn_controller']}" == 'opendaylight' ]]; then
278     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
279       LIBGUESTFS_BACKEND=direct virt-customize --run-command "rm -rf /opt/opendaylight/*" \
280                                                --run-command "tar zxvf /root/odl-netvirt-vpp-distribution.tar.gz -C /opt/opendaylight/" \
281                                                -a overcloud-full.qcow2
282 EOI
283   fi
284
285   # check if ceph should be enabled
286   if [ "${deploy_options_array['ceph']}" == 'True' ]; then
287     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/storage-environment.yaml"
288   fi
289
290   if [ "${deploy_options_array['sdn_controller']}" == 'ovn' ]; then
291     # The epoch in deloran's ovs is 1: and in leif's is 0:
292     # so we have to execute a downgrade instead of an update
293     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
294       LIBGUESTFS_BACKEND=direct virt-customize \
295         --run-command "cd /root/ovs27 && yum update -y *openvswitch*" \
296         --run-command "cd /root/ovs27 && yum downgrade -y *openvswitch*" \
297         -a overcloud-full.qcow2
298 EOI
299   fi
300
301   # get number of nodes available in inventory
302   num_control_nodes=$(ssh -T ${SSH_OPTIONS[@]} "root@$UNDERCLOUD" "grep -c profile:control /home/stack/instackenv.json")
303   num_compute_nodes=$(ssh -T ${SSH_OPTIONS[@]} "root@$UNDERCLOUD" "grep -c profile:compute /home/stack/instackenv.json")
304
305   # check if HA is enabled
306   if [[ "$ha_enabled" == "True" ]]; then
307     if [ "$num_control_nodes" -lt 3 ]; then
308       echo -e "${red}ERROR: Number of control nodes in inventory is less than 3 and HA is enabled: ${num_control_nodes}. Check your inventory file.${reset}"
309       exit 1
310     else
311      DEPLOY_OPTIONS+=" --control-scale ${num_control_nodes}"
312      DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/puppet-pacemaker.yaml"
313      echo -e "${blue}INFO: Number of control nodes set for deployment: ${num_control_nodes}${reset}"
314     fi
315   else
316     if [ "$num_control_nodes" -lt 1 ]; then
317       echo -e "${red}ERROR: Number of control nodes in inventory is less than 1: ${num_control_nodes}. Check your inventory file.${reset}"
318       exit 1
319     fi
320   fi
321
322   if [ "$num_compute_nodes" -le 0 ]; then
323     echo -e "${red}ERROR: Invalid number of compute nodes: ${num_compute_nodes}. Check your inventory file.${reset}"
324     exit 1
325   else
326     echo -e "${blue}INFO: Number of compute nodes set for deployment: ${num_compute_nodes}${reset}"
327     DEPLOY_OPTIONS+=" --compute-scale ${num_compute_nodes}"
328   fi
329
330   DEPLOY_OPTIONS+=" --ntp-server $ntp_server"
331
332   DEPLOY_OPTIONS+=" --control-flavor control --compute-flavor compute"
333   if [[ "$virtual" == "TRUE" ]]; then
334      DEPLOY_OPTIONS+=" -e virtual-environment.yaml"
335   fi
336
337   echo -e "${blue}INFO: Deploy options set:\n${DEPLOY_OPTIONS}${reset}"
338
339   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
340 # Create a key for use by nova for live migration
341 echo "Creating nova SSH key for nova resize support"
342 ssh-keygen -f nova_id_rsa -b 1024 -P ""
343 public_key=\'\$(cat nova_id_rsa.pub | cut -d ' ' -f 2)\'
344 sed -i "s#replace_public_key:#key: \$public_key#g" ${ENV_FILE}
345 python -c 'open("opnfv-environment-new.yaml", "w").write((open("${ENV_FILE}").read().replace("replace_private_key:", "key: \"" + "".join(open("nova_id_rsa").readlines()).replace("\\n","\\\n") + "\"")))'
346 mv -f opnfv-environment-new.yaml ${ENV_FILE}
347
348 source stackrc
349 set -o errexit
350 # Workaround for APEX-207 where sometimes swift proxy is down
351 if ! sudo systemctl status openstack-swift-proxy > /dev/null; then
352   sudo systemctl restart openstack-swift-proxy
353 fi
354 echo "Uploading overcloud glance images"
355 openstack overcloud image upload
356
357 echo "Configuring undercloud and discovering nodes"
358 openstack baremetal import --json instackenv.json
359
360 if [[ -z "$virtual" ]]; then
361   openstack baremetal introspection bulk start
362   if [[ -n "$root_disk_list" ]]; then
363     openstack baremetal configure boot --root-device=${root_disk_list}
364   else
365     openstack baremetal configure boot
366   fi
367 else
368   openstack baremetal configure boot
369 fi
370
371 echo "Configuring flavors"
372 for flavor in baremetal control compute; do
373   echo -e "${blue}INFO: Updating flavor: \${flavor}${reset}"
374   if openstack flavor list | grep \${flavor}; then
375     openstack flavor delete \${flavor}
376   fi
377   openstack flavor create --id auto --ram 4096 --disk 39 --vcpus 1 \${flavor}
378   if ! openstack flavor list | grep \${flavor}; then
379     echo -e "${red}ERROR: Unable to create flavor \${flavor}${reset}"
380   fi
381 done
382 openstack flavor set --property "cpu_arch"="x86_64" --property "capabilities:boot_option"="local" baremetal
383 openstack flavor set --property "cpu_arch"="x86_64" --property "capabilities:boot_option"="local" --property "capabilities:profile"="control" control
384 openstack flavor set --property "cpu_arch"="x86_64" --property "capabilities:boot_option"="local" --property "capabilities:profile"="compute" compute
385 echo "Configuring nameserver on ctlplane network"
386 dns_server_ext=''
387 for dns_server in ${dns_servers}; do
388   dns_server_ext="\${dns_server_ext} --dns-nameserver \${dns_server}"
389 done
390 neutron subnet-update \$(neutron subnet-list | grep -Ev "id|tenant|external|storage" | grep -v \\\\-\\\\- | awk {'print \$2'}) \${dns_server_ext}
391 sed -i '/CloudDomain:/c\  CloudDomain: '${domain_name} ${ENV_FILE}
392 echo "Executing overcloud deployment, this should run for an extended period without output."
393 sleep 60 #wait for Hypervisor stats to check-in to nova
394 # save deploy command so it can be used for debugging
395 cat > deploy_command << EOF
396 openstack overcloud deploy --templates $DEPLOY_OPTIONS --timeout 90
397 EOF
398 EOI
399
400   if [ "$interactive" == "TRUE" ]; then
401     if ! prompt_user "Overcloud Deployment"; then
402       echo -e "${blue}INFO: User requests exit${reset}"
403       exit 0
404     fi
405   fi
406
407   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
408 source stackrc
409 openstack overcloud deploy --templates $DEPLOY_OPTIONS --timeout 90
410 if ! openstack stack list | grep CREATE_COMPLETE 1>/dev/null; then
411   $(typeset -f debug_stack)
412   debug_stack
413   exit 1
414 fi
415 EOI
416
417   # Configure DPDK and restart ovs agent after bringing up br-phy
418   if [ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' ]; then
419     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI || (echo "DPDK config failed, exiting..."; exit 1)
420 source stackrc
421 set -o errexit
422 for node in \$(nova list | grep novacompute | grep -Eo "[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+"); do
423 echo "Checking DPDK status and bringing up br-phy on \$node"
424 ssh -T ${SSH_OPTIONS[@]} "heat-admin@\$node" <<EOF
425 set -o errexit
426 sudo dpdk-devbind -s
427 sudo ifup br-phy
428 if [[ -z "${deploy_options_array['sdn_controller']}" || "${deploy_options_array['sdn_controller']}" == 'False' ]]; then
429   echo "Restarting openvswitch agent to pick up VXLAN tunneling"
430   sudo systemctl restart neutron-openvswitch-agent
431 fi
432 EOF
433 done
434 EOI
435   fi
436
437   if [ "$debug" == 'TRUE' ]; then
438       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
439 source overcloudrc
440 echo "Keystone Endpoint List:"
441 openstack endpoint list
442 echo "Keystone Service List"
443 openstack service list
444 EOI
445   fi
446 }